var canvas;
var ctx;
var scalerate = 1;
var FPS = 30;			
var touchdev = false;	
var view = { w:480, h:480 };
var mouse = { x:0, y:0, ox:0, oy:0 };
var tickcount = 0;	
function trace(a){
	console.log(a);
}

// イベント関数
var timer_func = new Function();
var next_func = new Function();
var click_func = new Function();
var move_func = new Function();
var release_func = new Function();
var key_func = new Function();
function init_event_funcs(){
	timer_func = null;
	next_func = null;
	click_func = null;
	move_func = null;
	release_func = null;
	key_func = null;
}

// 画像ソース
var img = new Array();
var imgsrc = ["all.png","bg.png"];
var loadedimages = 0;

/*
// サウンド
var sounds = new Array();
var sndsrc = ["sound/btn.mp3","sound/card.mp3","sound/card2.mp3","sound/clear.mp3","sound/over.mp3"];
*/

window.addEventListener('load', window_onload );
function window_onload()
{
	if( navigator.userAgent.indexOf('iPhone') > 0
		|| navigator.userAgent.indexOf('iPod') > 0
		|| navigator.userAgent.indexOf('iPad') > 0
		|| navigator.userAgent.indexOf('Android') > 0
		|| navigator.userAgent.indexOf('Windows Phone') > 0 ) {
		touchdev = true;
	}
	if( touchdev ){
		scalerate = Math.min(window.innerWidth/view.w, window.innerHeight/view.h);
	}
	canvas = document.getElementById('canvas');		// canvas要素を取得
	canvas.width = view.w;
	canvas.height = view.h;
    canvas.style.width = view.w*scalerate+'px';
    canvas.style.height = view.h*scalerate+'px';
	ctx = canvas.getContext('2d');
	
/*	
ctx.mozImageSmoothingEnabled = false;
ctx.webkitImageSmoothingEnabled = false;
ctx.msImageSmoothingEnabled = false;
ctx.imageSmoothingEnabled = false;	
*/	
	if( touchdev ){
		canvas.ontouchstart = touchStartListner;
		canvas.ontouchmove = touchMoveListner;
		canvas.ontouchend = touchEndListner;
	}else{
		// マウス
		canvas.onmousedown = mouseDownListner;
		canvas.onmousemove = mouseMoveListner;
		canvas.onmouseup = mouseUpListner;
	}
	
	// 画像
	var i;
	for( i=0; i<imgsrc.length; i++ ){
		img[i] = new Image();
		img[i].src = imgsrc[i] + "?" + new Date().getTime();	// キャッシュでonloadが効かなくなる対策
		img[i].onload = function(){loadedimages++;}
	}
/*	
	// サウンド
	for( i=0; i<sndsrc.length; i++ ){
		sounds[i] = new Audio();
		sounds[i].src = sndsrc[i];
	}
*/	
	// イベント関数
	init_event_funcs();

	// loading画面へ
	frame_loop();
	timer_func = loading;
}

/*
// リサイズ時の処理
window.addEventListener('resize', window_onresize );
function window_onresize()
{
	if( touchdev ) return;
	scalerate = Math.min(window.innerWidth/view.w, window.innerHeight/view.h);
    canvas.style.width = Math.floor(view.w*scalerate)+'px';
    canvas.style.height = Math.floor(view.h*scalerate)+'px';
}
*/

window.addEventListener('unload', window_onunload );
function window_onunload(e)
{
//	save_data();
}

function frame_loop() {
	tickcount++;
	if( timer_func != null ) timer_func();
	setTimeout( frame_loop, 1000/FPS ); // 再帰
//	requestAnimationFrame( frame_loop );
}
function mouseDownListner(e) {
	if( click_func != null ){ adjustXY(e); click_func(); }
}
function mouseMoveListner(e) {
	if( move_func != null ){ adjustXY(e); move_func(); }
}
function mouseUpListner(e) {
	if( release_func != null ){ adjustXY(e); release_func(); }
}
function touchStartListner(e) {
	if( click_func != null ){ touchXY(e); click_func(); }
	e.preventDefault();
}
function touchMoveListner(e) {
	if( move_func != null ){ touchXY(e); move_func(); }
	e.preventDefault();
}
function touchEndListner(e) {
	if( release_func != null ){ release_func(); }
	e.preventDefault();
}
// マウス座標用
function adjustXY(e) {
	var rect = e.target.getBoundingClientRect();
	if( scalerate>0 ){
		mouse.x = (e.clientX-rect.left)/scalerate;
		mouse.y = (e.clientY-rect.top)/scalerate;
	}
}
// タッチ座標用
function touchXY(e) {
	var rect = e.target.getBoundingClientRect();
	mouse.x=e.touches[0].pageX-rect.left;
	mouse.y=e.touches[0].pageY-rect.top;
	if( scalerate>0 ){
		mouse.x /= scalerate;
		mouse.y /= scalerate;
	}
}


document.onkeyup = function (e){
	if(!e) e = window.event;
	if( e.keyCode==38 ){
		if( key_func != null ){
			key_func();
		}
	}
}


//////////////////////////////////////////////////////////////////////////

function cls() {
	ctx.fillStyle = "#ffffff";
	ctx.fillRect(0,0,view.w,view.h);
}
function copy_pat(n,sx,sy,w,h,bx,by,lr){
	if( lr ){
		ctx.transform(-1,0,0,1,0,0);
		ctx.drawImage( img[n], sx,sy,w,h, -(bx+w),by,w,h );
		ctx.transform(-1,0,0,1,0,0);
	}else{
		ctx.drawImage( img[n], sx,sy,w,h, bx,by,w,h );
	}
}
function stretch_copy(n,sx,sy,w,h,bx,by,w2,h2){
	ctx.drawImage( img[n], sx,sy,w,h, bx,by,w2,h2 );
}
function draw_rect(x,y,w,h,col,alpha) {
	ctx.globalAlpha = alpha;
	ctx.fillStyle = col;
	ctx.fillRect(x,y,w,h);
	ctx.globalAlpha = 1.0;
}
function round_rect(x, y, w, h, r, col, alpha)
{
	ctx.save();
	/*
	// dwopshadow
	ctx.shadowColor = "#000000";
	ctx.shadowBlur = 5;
	ctx.shadowOffsetX = 1;
	ctx.shadowOffsetY = 1;
	*/
	ctx.globalAlpha = alpha;
	ctx.fillStyle = col;
	ctx.beginPath();
	ctx.moveTo(x, y+r);
	ctx.arc(x+r,   y+h-r, r, Math.PI, Math.PI/2, true);
	ctx.arc(x+w-r, y+h-r, r, Math.PI/2, 0, true);
	ctx.arc(x+w-r, y+r,   r, 0, Math.PI*3/2, true);
	ctx.arc(x+r,   y+r,   r, Math.PI*3/2, Math.PI, true);
	ctx.closePath();
	ctx.fill();
	ctx.globalAlpha = 1.0;
	ctx.restore();		
}

function draw_circle(x,y,r, col) {
	ctx.fillStyle = col;
	ctx.beginPath();
	ctx.arc(x,y, r, 0, Math.PI*2, true);	
	ctx.fill();
}
function draw_text(x, y, str, size, col, alpha) {
	ctx.globalAlpha = alpha;
	ctx.fillStyle = col;
	ctx.textAlign = 'center';
	ctx.textBaseline = 'middle';
	ctx.font = size + "px 'Roboto'";
	ctx.fillText(str,x,y);
	ctx.globalAlpha = 1.0;
}
function draw_fade(x,y,w,h,col,a) {
	if ( a < 0 ) a = 0;
	if ( a > 100 ) a = 100;
	ctx.globalAlpha = a / 100;
	ctx.fillStyle = col;
	ctx.fillRect(x,y,w,h);
	ctx.globalAlpha = 1.0;
}


//////////////////////////////////////////////////////////////////////////

// 画像のローディング
function loading() {
	cls();
	var ox = view.w / 2;
	var oy = view.h / 2;
	
	var px = [0,1,1,1,0,-1,-1,-1];
	var py = [-1,-1,0,1,1,1,0,-1];
	var c = Math.floor(tickcount/3) % 8;
	var w = 4;
	
	var i;
	for ( i=0; i<8; i++ ) {
		ctx.fillStyle = (i==c) ? "#ffffff" : "#444444";
		var x = ox + px[i] * w;
		var y = oy + py[i] * w;
		ctx.fillRect(x-w/2, y-w/2, w-1, w-1);
	}
	
	if( loadedimages < imgsrc.length ) return;

	timer_func = null;
	start_game();
}




