
var xmax = 2;
var ymax = 4;
var cmax = 16;
var cel_w = 80;
var cel_h = 80;
var cel = new Array();
var wid = [80,46,8,22,54,80];
var mekuri = 0;
var erase = 0;
var wc = 0;
var timer = {visible:false, active:false, st:0, rt:0, lim:25000 };
var starter = {visible:false};
var gover = {visible:false, stat:0, bg:0};
var comp = {visible:false, flag:false, stat:0, c:0, logo:false };
var bg = {ox:0,oy:0,w:0,h:0};
var btn = {visible:false,x:0,y:0,w:0,h:0,txt:""};


// ゲーム初期化
function start_game()
{
	xmax = 4;
	ymax = 4;
	start_waiting();
}

// 「クリックでスタート」画面
function start_waiting()
{
	var i,j,n,r,tmp,a,w,h;
	
	cmax = xmax * ymax;
	for( i=0; i<cmax; i++ ){
		cel[i] = new Object();
		cel[i].exist = false;
		cel[i].fn = 0;
		cel[i].x = 0;
		cel[i].y = 0;
	}

	// パターンの並びとシャッフル
	var pats = [0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7];
	for( i=0; i<cmax; i++ ){
		r = Math.floor(Math.random()*cmax);
		tmp = pats[i];
		pats[i] = pats[r];
		pats[r] = tmp;
	}
	
	a = 4;	// カード間隔の幅
	var ox = (view.w - xmax*cel_w - (xmax-1)*a)/2;
	var oy = (view.h - ymax*cel_h - (ymax-1)*a)/2;
	n = 0;
	for( i=0; i<ymax; i++ ){
		for( j=0; j<xmax; j++ ){
			cel[n].exist = false;
			cel[n].x = ox + (cel_w+a) * j;
			cel[n].y = oy + (cel_h+a) * i;
			cel[n].pat = pats[n];
			cel[n].fn = 0;	// フレーム番号
			cel[n].a = 0;		// フレーム加算
			n++;
		}
	}
	bg.w = cel_w*xmax+(xmax-1)*a+20;
	bg.h = cel_h*ymax+(ymax-1)*a+20;
	bg.ox = cel[0].x - 10;
	bg.oy = cel[0].y - 10;
	
	// タイマー
	timer.visible = false;
	timer.active = false;
	timer.rt = timer.lim;
	
	// start
	starter.visible = true;
	w = 200;
	h = 80;
	starter.x = (view.w-w)/2;
	starter.y = (view.h-h)/2;
	starter.w = w;
	starter.h = h;
	
	// gover
	gover.visible = false;
	
	// comp
	comp.visible = false;
	comp.flag = false;
	comp.logo = false;
	
	// btn
	btn.visible = false;
	
	draw_game();
	init_event_funcs();
	timer_func = waiting;
	click_func = click_waiting;
}

function waiting()
{
	draw_game();
}
function click_waiting()
{
	var mx = mouse.x;
	var my = mouse.y;
	if( mx<starter.x || mx>=starter.x+starter.w ) return;
	if( my<starter.y || my>=starter.y+starter.h ) return;
//	sounds[0].play();
	start_play();
}


// プレイ開始
function start_play()
{
	var i;
	for( i=0; i<cmax; i++ ){
		cel[i].exist = true;
	}

	mekuri = 0;	// めくった枚数

	timer.visible = true;
	timer.active = true;
	timer.st = new Date().getTime();
	
	starter.visible = false;
			
	init_event_funcs();
	click_func = click_card;
	timer_func = play_main;
}

// メインタスク
function play_main()
{
	var i;
	
	// カードアニメーション
	for( i=0; i<cmax; i++ ){
		if( !cel[i].exist ) continue;
		if( cel[i].a==0 ) continue;
		// フレーム加算
		cel[i].fn += cel[i].a;
		if( cel[i].fn>=5 ){
			cel[i].a = 0;
		}
	}
	
	if( mekuri>=2 ){
		wc--;
		if( wc<=0 ){
			if( check_pair() ){
				// ペアで消す
				for( i=0; i<cmax; i++ ){
					if( cel[i].fn>0 ) cel[i].exist = false;
				}
				// クリアチェック
				var c = 0;
				for( i=0; i<cmax; i++ ){
					if( cel[i].exist ) c++;
				}
				if( c==0 ) comp.flag = true;
				// 音
//				sounds[0].play();
			}else{
				// 違うカードは裏返す
				for( i=0; i<cmax; i++ ){
					cel[i].fn = 0;
				}
			}
			mekuri = 0;
		}
	}

	// タイマー
	if( timer.active ){
		var tc = new Date().getTime() - timer.st;
		timer.rt = timer.lim-tc;
		if( timer.rt<0 ) timer.rt=0;
	}
	
	draw_game();
	
	// GAMEOVERへ
	if( timer.rt<=0 ){
		gover.visible = true;
		gover.stat = 0;
		gover.bg = 0;
		gover.logo = 0;
		init_event_funcs();
		timer_func = gover_main;
	}
	/*
	comp.flag = true;
	for( i=0; i<cmax; i++ ){
		cel[i].exist = false;
	}
	*/
	// クリアへ
	if( comp.flag ){
		comp.visible = true;
		comp.stat = 0;
		comp.c = 0;
		comp.logo = false;
		init_event_funcs();
		timer_func = comp_main;
	}
}

// ペアチェック
function check_pair()
{
	var i;
	var c = 0;
	var pat = 0;
	var ret = false;
	for( i=0; i<cmax; i++ ){
		if( !cel[i].exist ) continue;
		if( cel[i].fn==0 ) continue;
		if( c==0 ){
			pat = cel[i].pat;
		}else if( c==1 ){
			if( cel[i].pat==pat ) ret=true;	// ペア
		}
		c++;
	}
	return ret;
}

// クリックしてめくる
function click_card()
{
	if( mekuri>=2 ) return;
	
	var i;
	var mx = mouse.x;
	var my = mouse.y;
	var n = -1;
	for( i=0; i<cmax; i++ ){
		if( !cel[i].exist ) continue;
		if( cel[i].fn>0 ) continue;
		var cx = cel[i].x;
		var cy = cel[i].y;
		if( mx<cx || mx>=cx+cel_w ) continue;
		if( my<cy || my>=cy+cel_h ) continue;
		n = i;
	}
	if( n<0 ) return;
	
	if( mekuri==0 ){
//		sounds[1].play();
	}else{
//		sounds[2].play();
	}
	
	cel[n].a = 1;
	mekuri++;
	if( mekuri>=2 ){
		// 二枚目開く
		wc = 22;

		var c = 0;
		for( i=0; i<cmax; i++ ){
			if( !cel[i].exist ) c++;
		}
		if( c+mekuri>=cmax ){
			timer.active = false;	// タイマーを止める
		}
	}
}

function gover_main()
{
	if( gover.stat==0 ){
		gover.bg+=4;
		if( gover.bg>=80 ){
//			sounds[4].play();
			gover.stat = 1;
			gover.logo = 0;
		}
	}else if( gover.stat==1 ){
		gover.logo+=4;
		if( gover.logo>=100 ){
			gover.stat=2;
			btn.visible = true;
			btn.w = 120;
			btn.h = 100;
			btn.x = view.w/2-btn.w/2;
			btn.y = view.h+10;
			btn.txt = "Retry";
		}
	}else if( gover.stat==2 ){
		btn.y-=20;
		if( btn.y<view.h/2+20 ){
			btn.y=view.h/2+20;
			gover.stat=3;
			click_func = gover_click;
		}
	}
	draw_game();
}
function gover_click()
{
	var mx = mouse.x;
	var my = mouse.y;
	if( mx<btn.x || mx>=btn.x+btn.w ) return;
	if( my<btn.y || my>=btn.y+btn.h ) return;
//	sounds[0].play();
	start_waiting();
}


function comp_main()
{
	if( comp.stat==0 ){
		comp.c++;
		if( comp.c>20 ){
			comp.c=0;
			comp.stat=1;
//			sounds[3].play();
		}
	}else if( comp.stat==1 ){
		comp.c++;
		if( Math.floor(comp.c%2)>0 ){
			comp.logo = true;
		}else{
			comp.logo = false;
		}
		if( comp.c>30 ){
			comp.logo = true;
			comp.stat= 2;
			btn.visible = true;
			btn.w = 160;
			btn.h = 100;
			btn.x = view.w/2-btn.w/2;
			btn.y = view.h+10;
			btn.txt = "End Game";
		}
	}else if( comp.stat==2 ){
		btn.y-=20;
		if( btn.y<view.h/2+20 ){
			btn.y=view.h/2+20;
			comp.stat=3;
			click_func = comp_click;
		}
	}
	draw_game();
}

function comp_click()
{
	var mx = mouse.x;
	var my = mouse.y;
	if( mx<btn.x || mx>=btn.x+btn.w ) return;
	if( my<btn.y || my>=btn.y+btn.h ) return;
	
	
	location.href = "https://www.gamedesign.jp/";
}


///////////////////////////////////////////////////////
// ゲームの描画
///////////////////////////////////////////////////////

function draw_game(){
	var i;
	
	/*
	cls();
	// BG
	round_rect(bg.ox-10,bg.oy-40,bg.w+20,bg.h+80,8,"#666666",1);
	round_rect(bg.ox,bg.oy,bg.w,bg.h,6,"#999999",1);
	draw_text(bg.ox+bg.w/2,bg.oy-20, "SHINKEISUIJAKU", 18, "#ffffff", 1);
	*/
	
	copy_pat(1,0,0,view.w,view.h,0,0,false);

	
	// タイマー
	var ox = view.w/2;
	var oy = cel[0].y/2;
	if( timer.visible ){
		var a = timer.rt+9;	// 残り0.01未満にならないように
		var txt=Math.floor(a/1000)+":"; a=a%1000;
		txt += Math.floor(a/100); a=a%100;
		txt += Math.floor(a/10);
		draw_text(ox, bg.oy+bg.h+20, txt, 20, "#ffffff", 1);
	}

	// カード
	for( i=0; i<cmax; i++ ){
		if( !cel[i].exist ) continue;
		var fn = cel[i].fn;
		var pat = cel[i].pat;
		if( fn<=2 ) pat = 8;
		var sx = Math.floor(pat%4)*cel_w;
		var sy = Math.floor(pat/4)*cel_h;
		var w = cel_w * wid[fn]/80;
		var h = cel_h;
		stretch_copy( 0,sx,sy,cel_w,cel_h, cel[i].x+(cel_w-w)/2,cel[i].y, w,h);
	}
	
	
	
	// スターター
	if( starter.visible ){
		round_rect(starter.x,starter.y,starter.w,starter.h,8,"#ffffff",1);
		draw_text(starter.x+starter.w/2, starter.y+starter.h/2, "START", 20, "#000000", 1);
	}
	// GAMEOVER
	if( gover.visible ){
		draw_rect(0,0,view.w,view.h,"#ffffff",gover.bg/100);
		draw_text(view.w/2, view.h/2-50, "G A M E O V E R", 30, "#000000", gover.logo/100);
	}
	// comp
	if( comp.visible ){
		if( comp.logo ){
			draw_text(view.w/2, view.h/2-50, "CONGRATULATIONS!", 30, "#ffffff", 1);
		}
	}
	if( btn.visible ){
		round_rect(btn.x,btn.y,btn.w,btn.h,8,"#000000",1);
		draw_text(btn.x+btn.w/2, btn.y+btn.h*0.5, btn.txt, 20, "#ffffff", 1);
	}
}





